<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_TechnicalStop ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_TechnicalStop extends AbstractStructArrayBase
{
    /**
     * The TechnicalStop
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_TechnicalStop[]
     */
    public $TechnicalStop;
    /**
     * Constructor method for ArrayOfJP_TechnicalStop
     * @uses ArrayOfJP_TechnicalStop::setTechnicalStop()
     * @param \StructType\JP_TechnicalStop[] $technicalStop
     */
    public function __construct(array $technicalStop = array())
    {
        $this
            ->setTechnicalStop($technicalStop);
    }
    /**
     * Get TechnicalStop value
     * @return \StructType\JP_TechnicalStop[]|null
     */
    public function getTechnicalStop()
    {
        return $this->TechnicalStop;
    }
    /**
     * Set TechnicalStop value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_TechnicalStop[] $technicalStop
     * @return \ArrayType\ArrayOfJP_TechnicalStop
     */
    public function setTechnicalStop(array $technicalStop = array())
    {
        foreach ($technicalStop as $arrayOfJP_TechnicalStopTechnicalStopItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_TechnicalStopTechnicalStopItem instanceof \StructType\JP_TechnicalStop) {
                throw new \InvalidArgumentException(sprintf('The TechnicalStop property can only contain items of \StructType\JP_TechnicalStop, "%s" given', is_object($arrayOfJP_TechnicalStopTechnicalStopItem) ? get_class($arrayOfJP_TechnicalStopTechnicalStopItem) : gettype($arrayOfJP_TechnicalStopTechnicalStopItem)), __LINE__);
            }
        }
        $this->TechnicalStop = $technicalStop;
        return $this;
    }
    /**
     * Add item to TechnicalStop value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_TechnicalStop $item
     * @return \ArrayType\ArrayOfJP_TechnicalStop
     */
    public function addToTechnicalStop(\StructType\JP_TechnicalStop $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_TechnicalStop) {
            throw new \InvalidArgumentException(sprintf('The TechnicalStop property can only contain items of \StructType\JP_TechnicalStop, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TechnicalStop[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_TechnicalStop|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_TechnicalStop|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_TechnicalStop|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_TechnicalStop|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_TechnicalStop|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TechnicalStop
     */
    public function getAttributeName()
    {
        return 'TechnicalStop';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_TechnicalStop
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
